



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>EntityFramework Core迁移时出现数据库已存在对象问题解决方案</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">EntityFramework Core迁移时出现数据库已存在对象问题解决方案</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 17:20:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>前言</h1>
<p>刚开始接触EF Core时本着探索的精神去搞，搞着搞着发现出问题了，后来就一直没解决，觉得很是不爽，借着周末好好看看这块内容。</p>
<h2>EntityFramework Core迁移出现对象在数据库中已存在</h2>
<p>在EF Core之前对于迁移的命令有很多，当进行迁移出现对象已在数据库中存在时我们通过如何命令即可解决：</p>
<div>
<pre class="prettyprint linenums">Add-Migration Initial -IgnoreChanges</pre>
</div>
<p>但是在EF Core对于迁移现如今只存在如下两个命令：</p>
<div>
<pre class="prettyprint linenums">dotnet ef migrations add &lt;&lt;migration_name&gt;&gt;<br />
dotnet ef database update</pre>
</div>
<p>当我们第一次进行初始化迁移时，表结构完全生成通过&nbsp;dotnet ef migration add initial&nbsp;来初始化表，当下次再进行迁移时因为这样或者那样无意的操作导致出现如下结果</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/589642/201706/589642-20170618125819243-938113498.png" /></p>
<p>翻译成英语则是如下的情况：</p>
<div>
<pre class="prettyprint linenums">There is already an object named in the database</pre>
</div>
<p>如下为第一次初始化的迁移文件，如下：</p>
<div>
<pre class="prettyprint linenums">    public partial class initial : Migration<br />
    {<br />
        protected override void Up(MigrationBuilder migrationBuilder)<br />
        {<br />
            migrationBuilder.CreateTable(<br />
                name: "Blog",<br />
                columns: table =&gt; new<br />
                {<br />
                    Id = table.Column&lt;int&gt;(nullable: false)<br />
                        .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),<br />
                    Code = table.Column&lt;string&gt;(nullable: false),<br />
                    Count = table.Column&lt;int&gt;(nullable: false),<br />
                    Name = table.Column&lt;string&gt;(nullable: true),<br />
                    Url = table.Column&lt;string&gt;(nullable: true)<br />
                },<br />
                constraints: table =&gt;<br />
                {<br />
                    table.PrimaryKey("PK_Blog", x =&gt; x.Id);<br />
                });

            migrationBuilder.CreateTable(<br />
                name: "Book",<br />
                columns: table =&gt; new<br />
                {<br />
                    Id = table.Column&lt;int&gt;(nullable: false)<br />
                        .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),<br />
                    Name = table.Column&lt;string&gt;(nullable: true)<br />
                },<br />
                constraints: table =&gt;<br />
                {<br />
                    table.PrimaryKey("PK_Book", x =&gt; x.Id);<br />
                });

            migrationBuilder.CreateTable(<br />
                name: "Category",<br />
                columns: table =&gt; new<br />
                {<br />
                    Id = table.Column&lt;int&gt;(nullable: false)<br />
                        .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),<br />
                    Name = table.Column&lt;string&gt;(nullable: true),<br />
                    ProductId = table.Column&lt;int&gt;(nullable: false)<br />
                },<br />
                constraints: table =&gt;<br />
                {<br />
                    table.PrimaryKey("PK_Category", x =&gt; x.Id);<br />
                });

            migrationBuilder.CreateTable(<br />
                name: "Product",<br />
                columns: table =&gt; new<br />
                {<br />
                    Id = table.Column&lt;int&gt;(nullable: false)<br />
                        .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),<br />
                    Code = table.Column&lt;string&gt;(nullable: true),<br />
                    Name = table.Column&lt;string&gt;(nullable: true)<br />
                },<br />
                constraints: table =&gt;<br />
                {<br />
                    table.PrimaryKey("PK_Product", x =&gt; x.Id);<br />
                });

            migrationBuilder.CreateTable(<br />
                name: "Post",<br />
                columns: table =&gt; new<br />
                {<br />
                    Id = table.Column&lt;int&gt;(nullable: false)<br />
                        .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),<br />
                    BlogId = table.Column&lt;int&gt;(nullable: false),<br />
                    Content = table.Column&lt;string&gt;(nullable: true),<br />
                    Title = table.Column&lt;string&gt;(nullable: true)<br />
                },<br />
                constraints: table =&gt;<br />
                {<br />
                    table.PrimaryKey("PK_Post", x =&gt; x.Id);<br />
                    table.ForeignKey(<br />
                        name: "FK_Post_Blog_BlogId",<br />
                        column: x =&gt; x.BlogId,<br />
                        principalTable: "Blog",<br />
                        principalColumn: "Id",<br />
                        onDelete: ReferentialAction.Cascade);<br />
                });

            migrationBuilder.CreateTable(<br />
                name: "ProductCategory",<br />
                columns: table =&gt; new<br />
                {<br />
                    Id = table.Column&lt;int&gt;(nullable: false)<br />
                        .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),<br />
                    CategoryId = table.Column&lt;int&gt;(nullable: false),<br />
                    ProductId = table.Column&lt;int&gt;(nullable: false)<br />
                },<br />
                constraints: table =&gt;<br />
                {<br />
                    table.PrimaryKey("PK_ProductCategory", x =&gt; x.Id);<br />
                    table.ForeignKey(<br />
                        name: "FK_ProductCategory_Category_CategoryId",<br />
                        column: x =&gt; x.CategoryId,<br />
                        principalTable: "Category",<br />
                        principalColumn: "Id",<br />
                        onDelete: ReferentialAction.Cascade);<br />
                    table.ForeignKey(<br />
                        name: "FK_ProductCategory_Product_ProductId",<br />
                        column: x =&gt; x.ProductId,<br />
                        principalTable: "Product",<br />
                        principalColumn: "Id",<br />
                        onDelete: ReferentialAction.Cascade);<br />
                });

            migrationBuilder.CreateIndex(<br />
                name: "IX_Post_BlogId",<br />
                table: "Post",<br />
                column: "BlogId");

            migrationBuilder.CreateIndex(<br />
                name: "IX_ProductCategory_CategoryId",<br />
                table: "ProductCategory",<br />
                column: "CategoryId");

            migrationBuilder.CreateIndex(<br />
                name: "IX_ProductCategory_ProductId",<br />
                table: "ProductCategory",<br />
                column: "ProductId");<br />
        }

        protected override void Down(MigrationBuilder migrationBuilder)<br />
        {<br />
            migrationBuilder.DropTable(<br />
                name: "Book");

            migrationBuilder.DropTable(<br />
                name: "Post");

            migrationBuilder.DropTable(<br />
                name: "ProductCategory");

            migrationBuilder.DropTable(<br />
                name: "Blog");

            migrationBuilder.DropTable(<br />
                name: "Category");

            migrationBuilder.DropTable(<br />
                name: "Product");<br />
        }</pre>
</div>
<p>此时为了解决上述问题前提是最初的迁移类文件还在，我们需要将Up方法里面的数据全部删除而对于Down方法里面的数据可删除可不删除</p>
<div>
<pre class="prettyprint linenums">    public partial class initial : Migration<br />
    {<br />
        protected override void Up(MigrationBuilder migrationBuilder)<br />
        {}

        protected override void Down(MigrationBuilder migrationBuilder)<br />
        {<br />
              ........<br />
        }<br />
    }    </pre>
</div>
<p>通过Up方法来创建表或者修改列，通过Down方法来删除表或者修改列。上面我们创建了BlogType列，此时我们在映射时将其删除同时在Blog类中删除此字段，如下：</p>
<div>
<pre class="prettyprint linenums">    public class BlogMap : EntityMappingConfiguration&lt;Blog&gt;<br />
    {<br />
        public override void Map(EntityTypeBuilder&lt;Blog&gt; b)<br />
        {<br />
            b.ToTable("Blog");<br />
            b.HasKey(k =&gt; k.Id);

            b.Property(p =&gt; p.Count);<br />
            b.Property(p =&gt; p.Url);<br />
            b.Property(p =&gt; p.Name);

            b.Property(p =&gt; p.Code).IsRequired();<br />
            //b.Property(p =&gt; p.BlogType).HasColumnType("TINYINT").IsRequired();<br />
        }<br />
    }</pre>
</div>
<p>此时我们再来进行迁移如下：</p>
<div>
<pre class="prettyprint linenums">dotnet ef migrations add removeBlogType</pre>
</div>
<p>此时将不会再报错且生成的removeBlogType迁移类文件如下：</p>
<div>
<pre class="prettyprint linenums">    public partial class removeBlogType : Migration<br />
    {<br />
        protected override void Up(MigrationBuilder migrationBuilder)<br />
        {<br />
            migrationBuilder.DropColumn(<br />
                name: "BlogType",<br />
                table: "Blog");<br />
        }

        protected override void Down(MigrationBuilder migrationBuilder)<br />
        {<br />
            migrationBuilder.AddColumn&lt;byte&gt;(<br />
                name: "BlogType",<br />
                table: "Blog",<br />
                type: "TINYINT",<br />
                nullable: false,<br />
                defaultValue: (byte));<br />
        }<br />
    }</pre>
</div>
<p>我们需要再次确保生成的迁移类文件是否是我们需要修改的字段或者对列进行修改的方法是否正确，确保无误后，接下来再来通过&nbsp;dotnet ef database update&nbsp;更新到数据库中</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/589642/201706/589642-20170618134211790-410045048.png" /></p>
<p>如上通过意外情况导致上述错误，若是将最初迁移的整个文件夹删除了肿么办，这个时候真的没有好的办法了，我能想到的是：最好事先在建立项目时建立数据库对比文件，此时就会派上用场不用一个个类去核对表同时也利于部署时进行数据迁移。</p>
<h2>总结</h2>
<p>本文我们讲到了在EF Core迁移时可能出现的意外情况，若是删除了最初的迁移类文件也给出了能够想到的方案，不知看到此文的你有何高见？连续发表的EF Core文章都是在项目使用中遇到的问题，所以借此机会重新过了一遍，欢迎一起探讨。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mjlgr8.html">怎样在IDEA中使用JUnit4和JUnitGenerator V2&period;0自动生成测试模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvdm1oq.html">Java整型与字符串相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1pnl6q.html">ORACLE设置id自增长</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx44rd9.html">（四）装饰模式-C&plus;&plus;实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyl77j8.html">算法手记 之 数据结构&lpar;线段树详解&rpar;&lpar;POJ 3468&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/495oj1v8.html">PlaceholderImageView</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ok4j9.html">JavaScript、Jquery选择题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedr6x9.html">事件委托&lpar;event delegation&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x13zz8.html">Am命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd2j1y8.html">MFC新婚之夜（笑昏，大概是指MFC的人固步自封）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zz07x9.html">开源Math&period;NET基础数学类库使用&lpar;09&rpar;相关数论函数使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkr569.html">Dojo初探之2&colon;设置dojoConfig详解，dojoConfig参数详解&plus;Dojo中预置自定义AMD模块的四种方式（基于dojo1&period;11&period;2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwdwy8.html">&lbrack;leetcode-623-Add One Row to Tree&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg662d8.html">【Alpha】 第七次Daily Scrum Meeting</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj6y2k8.html">spring事务源码分析结合mybatis源码&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95grdx0q.html">mybatis ResultMap详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mlrj9.html">SQL Server与SQL Server Express的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwr6xv9.html">Ubuntu18&period;04 下修改 root密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ek7dq.html">elastic search 查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k035oq.html">ThinkPad 复刻计划 ThinkPad Time Machine</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96py0dj8.html">bzoj4828 &lbrack;Hnoi2017&rsqb;大佬</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1rdyyq.html">从零开始构建一个的asp&period;net Core 项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpvnz69.html">Windows下主机名和IP映射设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1klp029.html">Docker - 终端交互</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpzdmvq.html">Linux下memcache的安装和启动测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kljk69.html">关于cisco ccp 或sdm管理gns3中思科路由器的成功分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyjo3z9.html">JavaScript常用的方法和函数（setInterval和setTimeout）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojgge1q.html">调试 Dockerfile - 每天5分钟玩转 Docker 容器技术（15）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpzzmxq.html">Kafka学习-简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pydo48.html">JAVA中线程的状态</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
